// qt 3.3.6, X 6.9.0, MOPSLinux 5 (Slackware 11)
// 1)           (   myclass::myslot())
// 2) qmake -project; qmake
// 3)   Makefile -    LIBS = ... -lXext  -lXtst
// 4) make
//         "XLib unexpected async reply"    
//  bdimych@narod.ru

#include "qtctcl.h"

#define change_layout_keycode 116 // right win -     

class mymimesource : public QMimeSource //     .   kclipboard.cpp
{
	public: mymimesource( const QMimeSource * src )
		: QMimeSource(), m_formats( true ) // deep copies!
	{
		m_formats.setAutoDelete( true );
		m_data.setAutoDelete( true );
		if ( src )
		{
			QByteArray *byteArray;
			const char *format;
			int i = 0;
			while ( (format = src->format( i++ )) )
			{
				if (strstr(format, "_RDESKTOP_NATIVE")) continue; //        rdesktop       ,     Segmentation fault     
				byteArray = new QByteArray();
				*byteArray = src->encodedData( format ).copy();
				m_data.append( byteArray );
				m_formats.append( format );
			}
		}
	}
	~mymimesource() {}
	virtual const char *format( int i ) const {
		if ( i < (int) m_formats.count() )
			return m_formats.at( i );
		else
			return 0L;
	}
	virtual bool provides( const char *mimeType ) const {
		return ( m_formats.find( mimeType ) > -1 );
	}
	virtual QByteArray encodedData( const char *format ) const
	{
		int index = m_formats.find( format );
		if ( index > -1 ) return *(m_data.at( index ));
		return QByteArray();
	}
	private:
		mutable QStrList m_formats;
		mutable QPtrList<QByteArray> m_data;
};

////////////////////////////////////////////////////////////////////////////////////////////////////

static Display *g_d = XOpenDisplay(NULL);
static bool g_pleasewait = false;

//  XFlush      
static void mykeyevent(int k, bool push) {
	XTestFakeKeyEvent(g_d, k, push, 10); XFlush(g_d);
}

myclass::myclass( QObject * parent, const char * name ) {
	QTextCodec *codec = QTextCodec::codecForName("KOI8-R");
	QString e = "`~@#$%^&qQwWeErRtTyYuUiIoOpP[{]}aAsSdDfFgGhHjJkKlL;:'\"zZxXcCvVbBnNmM,<.>/?";
	QString r = codec->toUnicode("\"");
		r.append(QChar::QChar(8470)); //  
		r += codec->toUnicode(";%:?.,");

	for (uint i = 0; i < e.length(); i++) {
//qDebug(e[i] + "(%d) " + r[i] + "(%d)", e[i].unicode(), r[i].unicode());
		er[e[i]] = r[i];
		re[r[i]] = e[i];
	}
//exit(0);
	step = 0;
	qDebug("running...");
}

void myclass::myslot() {
	if (step == 0) qDebug("\n\n\n");
	qDebug("step = %d", step);
	switch (step) {
		case 0:
			// case 0  ..   firefox                       
			oldcbdata = new mymimesource(cb->data());
			step = -1;
			startTimer( 100 );
			break;
		case -1:
			cb->setText("magicktext"); //   firefox -  selection owner
			step = 1;
			startTimer( 100 );
			break;
		case 1:
//			mykeyevent(37, True); // ctrl+c = 54, ctrl+x = 53 
//			mykeyevent(54, True);
//			mykeyevent(54, False);
//			mykeyevent(37, False);

			//  firefox 2.0      ctrl+c - ctrl+v 
			mykeyevent(37, True); // ctrl+insert = 106 
			mykeyevent(106, True);
			mykeyevent(106, False);
			mykeyevent(37, False);

			startTimer( 1000 );
			QObject::connect( cb, SIGNAL(dataChanged()), this, SLOT(myslot()) );
			step = 2;
			break;
		case 2:
			killTimers();
			selstr = cb->text();
			qDebug("selstr = " + selstr);
//for (uint i=0; i<selstr.length(); i++) {qDebug(selstr[i] + " %d", selstr[i].unicode());}
//step = 0; return;
			newstr = convert(selstr);
			if ("magicktext" == selstr //       
					|| newstr == selstr) { //    
				qDebug("magicktext == selstr || newstr == selstr");
				QObject::disconnect( cb, SIGNAL(dataChanged()), this, SLOT(myslot()) );
				step = 0;
				g_pleasewait = false;
				cb->setData(oldcbdata);
				return;
			}
			qDebug("newstr = " + newstr);
			step = 3;
			cb->setText(newstr);
			startTimer( 1000 );
			break;
		case 3:
			killTimers();
			qDebug("cb->text() = " + cb->text());

//			mykeyevent(37, True); // ctrl+v
//			mykeyevent(55, True);
//			mykeyevent(55, False);
//			mykeyevent(37, False);

			//  firefox 2.0      ctrl+c - ctrl+v 
			mykeyevent(50, True); // shift+insert
			mykeyevent(106, True);
			mykeyevent(106, False);
			mykeyevent(50, False);

//   firefox       ->       ..  firefox     ->    shift+pause ->      QClipboard::setData: Cannot set X11 selection owner for CLIPBOARD    .                  .       - . case -1:

			step = 4;
			startTimer( 500 ); //        
			break;
		case 4:
			cb->setData(oldcbdata);
			if (! altpressed) {
				mykeyevent(change_layout_keycode, True);
				mykeyevent(change_layout_keycode, False);
			}
			step = 0;
			g_pleasewait = false;
			qDebug("END");
	}
}

void myclass::timerEvent( QTimerEvent *e )
{
	qDebug("timerEvent, step = %d, cb->text() = " + cb->text(), step);
	killTimers();
	if (step == 1 || step == -1
		|| step == 2 //    firefox -               2    dataChanged  cb->text()     qDebug            data   Changed  
	) {myslot(); return;}
	QObject::disconnect( cb, SIGNAL(dataChanged()), this, SLOT(myslot()) );
	if (step == 4) {myslot();} else {step = 0; g_pleasewait = false; cb->setData(oldcbdata);}
}

QString myclass::convert( QString in )
{
	QString out;
	if (altpressed) {
		for (uint i = 0; i < in.length(); i++)
		{
			if (iswlower(in[i].unicode())) {out += in[i].upper();} else {out += in[i].lower();}
		}
	} else {
		int prev_chr_lang = 0;
		for (uint i = 0; i < in.length(); i++)
		{
			if (er.contains(in[i]) && re.contains(in[i]) && prev_chr_lang > 0) {
				if (prev_chr_lang == 1) {out += er[in[i]];} else {out += re[in[i]];}
			}
			else if (er.contains(in[i])) {out += er[in[i]]; prev_chr_lang = 1;}
			else if (re.contains(in[i])) {out += re[in[i]]; prev_chr_lang = 2;}
			else {out += in[i];}
		}
	} 
	return out;
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void mythread::run()
{
	while (true) {
		msleep(100);
		if (g_pleasewait) continue;
		qApp->lock(); // lock/unlock    "XLib unexpected async reply"
		if (XPending(g_d) == 0) {qApp->unlock(); continue;} //  qApp     XNextEvent  Konqueror (     ,  )               - 
		XEvent e;
		XNextEvent(g_d, &e);
		if (! (e.xkey.state & Mod1Mask) && ! (e.xkey.state & ShiftMask)) {qApp->unlock(); continue;}
		if (e.xkey.state & Mod1Mask) {
			myobj->altpressed = true;
		} else if (e.xkey.state & ShiftMask) {
			myobj->altpressed = false;
		}
		if (e.type == 3) {
			g_pleasewait = true;
//			msleep(100); //  async reply           100%  kompozer  50%  mozille
			QApplication::postEvent(b, new QMouseEvent(QEvent::MouseButtonPress, QPoint(1, 1), Qt::LeftButton, 0));
			msleep(100);
			QApplication::postEvent(b, new QMouseEvent(QEvent::MouseButtonRelease, QPoint(1, 1), Qt::LeftButton, 0));
		}
		qApp->unlock();
	};
}

////////////////////////////////////////////////////////////////////////////////////////////////////

int main( int argc, char **argv )
{
	QApplication *a = new QApplication( argc, argv );

	XGrabKey(g_d, 110, AnyModifier, DefaultRootWindow(g_d), FALSE, GrabModeAsync, GrabModeAsync); // 110 = pause
	//  pause       AnyModifier          

	QPushButton *b = new QPushButton( "Ok", 0 );
//	b->show();
//	b->resize( 75, 35 );
//	a->setMainWidget( b );

	QClipboard *cb = QApplication::clipboard();

	myclass *myobj = new myclass(); myobj->cb = cb;
	QObject::connect( b, SIGNAL(clicked()), myobj, SLOT(myslot()) );

	mythread *mt = new mythread(); mt->myobj = myobj; mt->b = b; mt->start();

	//    "        -> postEvent     -> myobj myslot"    " "      

	return a->exec();
}

